	IFndef MACROS_DEFINED
MACROS_DEFINED:

****************** Macros ********************
adx:	MACRO	; // Add d to x
	pshx
	addd	2,sp+
	tfr	d,x
	ENDM

cmpl:	MACRO
	; \1 \2
	pshd
	pshx
	pshy
	
	ldx	#\1
	ldy	#\2
	
	ldd x
	cpd y
	bne \@END
	
	ldd 1,x
	cpd 1,y
	
\@END:
	puly
	pulx
	puld
	ENDM

errorMacro:	MACRO
\1:
	jsr	printSerialMessage
	lbra 	deadLoop
	dc.b	\2
	dc.b	EOT
	ENDM

textOutMacro:	MACRO
	jsr	printSerialMessage
	lbra	textOutMacroSkip\@
	dc.b	\1
	dc.b	EOT
textOutMacroSkip\@:
	ENDM
	
textOutMacroCRLF:	MACRO
	jsr	printSerialMessageCRLF
	lbra	textOutMacroSkip\@
	dc.b	\1
	dc.b	EOT
textOutMacroSkip\@:
	ENDM

print16Macro:	MACRO
	psha
	ldaa \1
	jsr SEND_A
	ldaa \1+1
	jsr SEND_A
	pula
	ENDM

; store 32bit number off stack into mem
stk32:	MACRO
	ldx #\1
	pula
	staa 1,x+
	pula
	staa 1,x+
	pula
	staa 1,x+
	pula
	staa 1,x+
	ENDM
	
; 32bit add - [x][y]=>stack
add32:	MACRO
	pshd
	pshx
	pshy
	
	ldx #\1
	ldy #\2
	
	ldaa 3,x
	adda 3,y
	psha
	ldaa 2,x
	adca 2,y
	psha
	ldaa 1,x
	adca 1,y
	psha
	ldaa x
	adca y
	psha

	stk32 \3

	puly
	pulx
	puld
	ENDM

	
; 16bit multiply [x][y]=>stack (32bit result)
mul16:	MACRO
	pshd
	pshy
	
	ldd	\1
	ldy	\2
	emul
	sty	\3
	std	\3+2
	
	puly
	puld
	ENDM
	
; 32bit / 32bit divide
div32:	MACRO
	pshd
	pshy
	pshx
	
	; \1.l divided by \2.l -> \3.l
	ldy	\1
	ldd	\1+2
	ldx	\2
	ediv	; y,rem d
	sty	\3
	
	pulx
	puly
	puld
	ENDM
	
	ENDIF
