	INCLUDE "p:\Cosc362\project\Equates12.asm"
	INCLUDE "p:\Cosc362\project\PrimarySoundBuffer.asm"
	INCLUDE "p:\Cosc362\project\Macros.asm"
	INCLUDE "p:\Cosc362\project\Midi.asm"
	INCLUDE "p:\Cosc362\project\MidiSongs.asm"
	INCLUDE "p:\Cosc362\project\General.asm"
	INCLUDE "p:\Cosc362\project\keypad.asm"
	INCLUDE "p:\Cosc362\project\lcd.asm"
	INCLUDE "p:\Cosc362\project\SoundRender.asm"
	INCLUDE "p:\Cosc362\project\Samples.asm"
	
	XDEF main
	
myCode: SECTION
	sampleRate:	equ.w		$2d7	; $16B-22Khz $1F4-16Khz $29A-12Khz $2d7-TC7-11Khz $3E8-8khz $535-6khz
	transpose:	equ.b 		0	; 
	rateh:		equ.w		$9	; $121000-22KHz, $D2745-16KHz, $9DA2E-12KHz, $90800-11KHz, $70000-8Khz, $4ED17-6KHz
	ratel:		equ.w		$800
	noteOndecayRate:	equ.w		1	; note end decay rate
	noteOffdecayRate:	equ.w		128	; note end decay rate
	
	introText:	dc.b		"            Midi Juke Box               ",0
	introText2:	dc.b		"      Press any key view selection      ",0
	selectionText:	dc.b		" 1-Courting 2-Ghosts'n'Goblins 3-Dixie  ",0
	selectionText2:	dc.b		"   4-Music Box Dancer 5-BubbleBobble    ",0
	playingText:	dc.b		"  Playing song - press any key to stop ", 0
	
main:		; //******************************************************
	clr	COPCTL 			; turn off COP

	lds	#STACK			; initialize stack
	
	jsr 	INITKEY			; initialise keypad
	jsr 	INITLCD			; initialise lcd panel
	
loop:
	ldx	#introText		; display introduction text
	jsr 	LCDSTR
	ldx	#introText2		; display introduction text
	jsr 	LCDSTR
	
	ldx	#selectionText		; request user to select a midi file
	jsr 	LCDSTR
	ldx	#selectionText2		; request user to select a midi file
	jsr 	LCDSTR
	
waitForKey:				; wait until a 1,2,3 or 4 selection is made
	jsr	GETKEY
	cmpa	#'1'
	blt	waitForKey
	cmpa	#'5'
	bgt	waitForKey
	
	suba	#'1'			; lookup pointer to midi file given song selection
	lsla
	ldx	#songList
	ldx	a,x
	stx	TrackPtr
	
	jsr 	KEYWAIT2; wait for keys to be released
	
	jsr	CLEARLCD		; clear LCD
	ldx	#playingText		; display playing now text
	jsr	LCDSTR

	jsr	initSoundRender

	jsr	resetSoundBuffer
	jsr	startSoundInterrupt
	
	jsr	resetMidi
	jsr	readMidiHeader
	jsr	readMidiTrack
	
	jsr	stopSoundInterrupt

	bra	loop			; do it all again