	INCLUDE "p:\Cosc362\project\Macros.asm"

	XDEF playNextSoundSample_int

myBuffer: SECTION
	bufferLength: 		equ.b 64*2
	bufferStartPtr:		ds.b bufferLength
	bufferEndPtr:		equ.w bufferStartPtr+bufferLength
	
myData: SECTION
	bufferTimePos:		dc.l 0   ; this is +ve or 0 for midi should play -ve for fillBuffer to fill
	bufferInsertPtr:	dc.w 0
	bufferRemovePtr:	dc.w 0
	
myCode: SECTION			; //******************************************************
resetSoundBuffer:
	pshd
	pshx
	pshy
	
	movw	#bufferStartPtr, bufferInsertPtr
	movw	#bufferStartPtr, bufferRemovePtr
	movw	#0, bufferTimePos
	
	bset	DDRT,%11111111	; // set port T to be all outputs

	clra
	staa	PORTT
	
	ldx	#bufferStartPtr
	ldaa	#bufferLength
	ldab	#$80
clearBufferLoop:
	stab	1,x+
	dbne	a,clearBufferLoop
	
	puly
	pulx
	puld
	rts

startSoundInterrupt:
	pshd
	pshx
	pshy
	
	clr	CFORC
	clr	OC7M
	clr	OC7D			; all timers disconnected from PORTT
	clr	TCTL1
	clr	TCTL2
	clr	TCTL3
	clr	TCTL4			; all timers disconnected from PORTT
	
	movb	#%10000000,TMSK1	; enable IOC channel 7 interrupt
	movb	#%10000000,TIOS		; enable IOC channel 7 to output
	
	movb	#%00001000, TMSK2 	;
	bset	TFLG1, #%10000000 	; reset interrupt tc07
	movb	#%11100000, TSCR 	; enable timer, fast flag clear
	movw	#sampleRate, TC7	; Khz interrupt 
	
	cli				; enable interrupts
	
	puly
	pulx
	puld
	rts
	
stopSoundInterrupt:
	movb	#%01100000, TSCR 	; disable timer, fast flag clear
	
	rts
	
playNextSoundSample_int:		; // this done on interrupt so no stack storage required
	ldx	bufferRemovePtr
	cpx	bufferInsertPtr

	beq	playNextSoundSample_noSampleReady
	ldd	2,x+			; load next sample to play
	
	addd	#($7FFF-256)		; convert from 16bits to 8bits for output
	lsrd				; todo just store in port and use wiring to do lsr
	stab	PORTT			; store sample in output port T
	
	tfr	x,d
	andb	#%1111111
	std	bufferRemovePtr		; make sure buffer doesn't overflow
	
playNextSoundSample_noSampleReady:
	bset	TFLG1, #%10000000	; reset interrupt  tc07
	rti