	IFndef SOUND_RENDER_DEFINED
SOUND_RENDER_DEFINED:

	INCLUDE "p:\Cosc362\project\Samples.asm"

myData: SECTION
	channelsFillBufferMaxPtr:	dc.w 0
	channelsFillBufferMax:		dc.w 0
	_temp3:				dc.w 0
	localBufferPtr:			dc.w 0
	minChannel:			dc.w 0
	minValue:			dc.w 0
	
ChannelMacro:   MACRO
	channel\1:
	chan\1_state:		dc.b 0 ; // 0 available, else envelope position
	chan\1_midiChannel:	dc.b 0 ; //
	chan\1_note:		dc.b 0 ; // note to play
	chan\1_volume:		dc.b 0 ; //
	chan\1_envVolume:	dc.w 0 ; // current envelope cycle volume, already modified by channel volume
	chan\1_envDelta:	dc.w 0 ; // current envelope cycle delta
	chan\1_samplePtr:	dc.w 0 ; // current sample ptr
	chan\1_sampleLoopStart:	dc.w 0 ;
	chan\1_sampleLoopEnd:	dc.w 0 ;
	chan\1_sampleSubPos:	dc.w 0 ;
	chan\1_sampleSubPosAdd:	dc.w 0 ;
	chan\1_sampleLoopStartEndDiff:	dc.w 0 ;
	
                 ENDM

	ChannelMacro 0
	ChannelMacro 1
	ChannelMacro 2
	ChannelMacro 3
	ChannelMacro 4
	ChannelMacro 5
	ChannelMacro 6
	ChannelMacro 7
	ChannelMacro 8
	ChannelMacro 9
	ChannelMacro A
	ChannelMacro B
	
myCode: SECTION			; //******************************************************
	channel_data_size:	equ.b channel1-channel0
	channel_count:		equ.b 12
	
initSoundRender:
	rts
	
FillBufferSubMacroADD:   	MACRO
	tst	chan\1_state 		; 3
	beq	SKIP\1			; 1

	; // envelopeVolume -= envelopeDecay;
	ldd	chan\1_envVolume	; 3 
	subd	chan\1_envDelta		; 3
	bmi	ENDSAMPLE\1		; 1
	std	chan\1_envVolume	; 2
	tfr	d,y			; 1
	
	; // 
	ldd	chan\1_sampleSubPos	; 3
	addd	chan\1_sampleSubPosAdd	; 3
	stab	chan\1_sampleSubPos+1	; 2
	
	; // v = samplePos++
	ldx	chan\1_samplePtr	; 2
	ldab	x			; 3
	leax	a,x			; 2
	
	cpx	chan\1_sampleLoopEnd	; 3 
	bge	RESET_SAMPLEPTR\1	; 1

BACK_FROM_RESET_SAMPLE_PTR\1:
	stx	chan\1_samplePtr	; 2
	; // [bufferInsertPos++] = v * envelopeVolume;
	sex	b,d			; 1
	emuls				; 3
	tfr	y,d			; 1
	addd	SP			; 3
	std	SP			; 2

	bra SKIP\1			; 3

RESET_SAMPLEPTR\1:
	exg	d,x			; 1
	subd	chan\1_sampleLoopStartEndDiff	; 3
	exg	d,x			; 1
	bra	BACK_FROM_RESET_SAMPLE_PTR\1
	
ENDSAMPLE\1:
	clr	chan\1_state

SKIP\1:
			ENDM

FillBuffer:
	; // if( bufferRemovePos==bufferInsertPos ) break;
	ldd	bufferInsertPtr		; 3
	std	localBufferPtr		; 2

FILL_BUFFER_LOOP:
	ldd	localBufferPtr		; 3
	cpd	channelsFillBufferMaxPtr; 3
	bne	NOT_BREAK		; 3
	rts
	
NOT_BREAK:
	ldd	#0
	pshd

	FillBufferSubMacroADD 0
	FillBufferSubMacroADD 1
	FillBufferSubMacroADD 2
	FillBufferSubMacroADD 3
	FillBufferSubMacroADD 4
	FillBufferSubMacroADD 5
	FillBufferSubMacroADD 6
	FillBufferSubMacroADD 7
	FillBufferSubMacroADD 8
	FillBufferSubMacroADD 9
	FillBufferSubMacroADD A
	FillBufferSubMacroADD B
	
	ldx	localBufferPtr
	puld
	std	2,x+
	tfr	x,d
	andb	#%1111111
	std	localBufferPtr
	
	lbra	FILL_BUFFER_LOOP	; 4

FILL_BUFFER:
	pshx
	pshy
	pshd

	ldd	bufferRemovePtr 		; // work out maximum buffer fill position
	cpd	bufferInsertPtr			; // find distance between insertptr and removeptr
	bgt	skipAdd				; // 
	addd	#bufferLength
skipAdd:
	subd	bufferInsertPtr			; // - 40
	subd	#2
	beq	skipBufferIsFull
	lsrd
	std	channelsFillBufferMax		; // distance relative to 0
	
	cpd	bufferTimePos			; // if available is less than bufferTimePos
	bcs	skip3				; //   then skip to end
	ldd	bufferTimePos			; //  else get bufferTimePos
	std	channelsFillBufferMax		; // store max length to store- remove ?
	
skip3:
	ldd	channelsFillBufferMax
		
	lsld
	addd	bufferInsertPtr			; // make relative to buffer insert ptr
	cpd	#bufferEndPtr			; // make sure buffer insert ptr doesn't go past buffer end
	bcs	skip2				;
	subd	#bufferLength			;

skip2:	
	std	channelsFillBufferMaxPtr


	jsr	FillBuffer

	; // set bufferTimePos to maxExpectTimePos
	movw 	channelsFillBufferMaxPtr, bufferInsertPtr
	ldd	bufferTimePos
	subd	channelsFillBufferMax
	std	bufferTimePos

skipBufferIsFull:
		
	puld
	puly
	pulx
	
	rts
	
**************************** getFreeChannel ****************************

findFreeChannel: ; // result in y
	pshd
	pshx
	
	; // look for empty channel
	ldy	#channel0
	ldx	#channel_count
	ldab	#channel_data_size

findFreeChannel_loop:
	tst	y
	beq	foundFreeChannel	
	aby
	dbne	x, findFreeChannel_loop
	
	; // no empty channel, look for channel in decay
	
	ldy	#channel0
	ldx	#channel_count
	ldab	#channel_data_size
	
findFreeChannel_loop2:
	ldaa	y
	cmpa	#2
	beq	foundFreeChannel	
	aby
	dbne	x, findFreeChannel_loop2
		
	; // no empty channels at all - use channel with lowest chan\1_envVolume	
	ldy	#channel0
	ldx	#channel_count

	movw	#$7fff, minValue
	movw	#channel0, minChannel
	
findFreeChannel_loop3: ; todo in future use the oldest note
	ldd	4,y
	cpd	minValue
	bgt findFreeChannel_loop3_skip
	
	sty	minChannel
	std	minValue
findFreeChannel_loop3_skip:
	ldab	#channel_data_size
	aby
	dbne	x, findFreeChannel_loop3

	ldy	minChannel

foundFreeChannel:
	pulx
	puld
	rts

**************************** findChannelNoteOn ****************************

findChannelNoteOn: 	; // result in y, inputs a=midi channel, b=note
	pshx
	
	tfr	d,x ; // x holds note,midi chan
	
	ldy	#channel0
	ldaa	#channel_count
	ldab	#channel_data_size

findChannelNoteOn_loop:
	exg	d,x ; // d holds note, midi chan, x holds counters
	
	tst	y
	beq	findChannelNoteOn_skip
	cmpa	1,y 	; // midiChannel
	bne	findChannelNoteOn_skip
	cmpb	2,y 	; // Note
	beq	foundChannelNoteOn
	
findChannelNoteOn_skip:
	exg	d,x ; // d holds counters, x holds note, midi chan
	aby
	dbne	a, findChannelNoteOn_loop
	
	ldy	#0
	
foundChannelNoteOn:
	pulx
	rts
	
**************************** areChannelsFinished ****************************

areChannelsFinished: ; // result in a, 0 is no, 1 is yes
	pshx
	pshy
	
	; // look for empty channel
	ldy	#channel0
	ldx	#channel_count
	ldab	#channel_data_size
	clra
	
areChannelsFinished_loop:
	tst	y
	bne	areChannelsFinished_loop_nope
	aby
	dbne	x, areChannelsFinished_loop
	
	; // all channels are finished
	inca
	puly
	pulx
	rts
	
areChannelsFinished_loop_nope:
	
	puly
	pulx
	rts
	
**************************** killAllChannels ****************************

killAllChannels: ; // result in a, 0 is no, 1 is yes
	pshx
	pshy
	
	; // look for empty channel
	ldy	#channel0
	ldaa	#channel_count
	ldab	#channel_data_size

killAllChannels_loop:
	movb	#2,y ; // state
	movw	#95, 6, y ; // decay
	aby
	dbne	a, killAllChannels_loop
	
	; // wait for all channels to finish playing
	movw	#$1000, bufferTimePos
	
killAllChannels_almostEnd:
	jsr	FILL_BUFFER
	jsr	areChannelsFinished
	cmpa	#1
	bne	killAllChannels_almostEnd
	
	puly
	pulx
	rts
	
**************************** findClosestSampleToNote ****************************

findClosestSampleToNote: ; // result in x, b, inputs a=note
	pshy

	ldy	#SAMPLE_COUNT
	ldab	#SAMPLE_ENTRY_SIZE
	ldx	#SAMPLE_ENTRYS
	
findClosestSampleToNote_loop:
	cmpa	x
	bge	foundNote
	abx
	dbne	y, findClosestSampleToNote_loop
	exg	d,x
	subd	#SAMPLE_ENTRY_SIZE
	exg	d,x
	
foundNote:
	; x now holds note ptr
	; scaling in d
	
	suba	x		; A now holds note difference
	adda	#24		; the note scaler starts at -12
	adda	#transpose
	
	cmpa	#96
	bge	noteScalingOutOfRange
	
foundNote_skip:
	lsla			; mul by 2 as scaling is in words
	ldy	#NOTE_SCALING
	ldd	a,y		; get scaler value
	
	puly
	
	rts
	
	errorMacro noteScalingOutOfRange,'noteScalingOutOfRange'
	errorMacro findChannelNoteOn_notFound,'findChannelNoteOn_notFound'
	
	
	ENDIF